/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.petra.concurrent;

import java.io.Serializable;

/**
 * @author Shuyang Zhou
 */
public class IdentityKey<K> implements Serializable {

	public IdentityKey(K key) {
		_key = key;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof IdentityKey)) {
			return false;
		}

		IdentityKey<K> identityKey = (IdentityKey<K>)obj;

		if (_key == identityKey._key) {
			return true;
		}

		return false;
	}

	public K getKey() {
		return _key;
	}

	@Override
	public int hashCode() {
		return _key.hashCode();
	}

	private static final long serialVersionUID = 1L;

	private final K _key;

}